#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum PeakDetectionMode {
    #[serde(rename = "POSITIVE")]
    Positive,
    #[serde(rename = "NEGATIVE")]
    Negative,
    #[serde(rename = "MEAN")]
    Mean,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl PeakDetectionMode {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            PeakDetectionMode::Positive => "POSITIVE",
            PeakDetectionMode::Negative => "NEGATIVE",
            PeakDetectionMode::Mean => "MEAN",
            PeakDetectionMode::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for PeakDetectionMode {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for PeakDetectionMode {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for PeakDetectionMode {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<PeakDetectionMode, conjure_object::plain::ParseEnumError> {
        match v {
            "POSITIVE" => Ok(PeakDetectionMode::Positive),
            "NEGATIVE" => Ok(PeakDetectionMode::Negative),
            "MEAN" => Ok(PeakDetectionMode::Mean),
            v => v.parse().map(|v| PeakDetectionMode::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for PeakDetectionMode {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<PeakDetectionMode, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the PeakDetectionMode enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
